package me.mrletsplay.bmareas.command;

import java.util.Arrays;

public enum Corner {
	
	NW("northwest", 0, 0),
	NE("northeast", 1, 0),
	SW("southwest", 0, 1),
	SE("southeast", 1, 1),
	CENTER("center", 0.5, 0.5);
	
	private final String name;
	private final double dX, dZ;
	
	private Corner(String name, double dX, double dZ) {
		this.name = name;
		this.dX = dX;
		this.dZ = dZ;
	}
	
	public String getName() {
		return name;
	}
	
	public double getDX() {
		return dX;
	}
	
	public double getDZ() {
		return dZ;
	}
	
	public static Corner getByName(String name) {
		return Arrays.stream(values())
				.filter(c -> c.getName().equalsIgnoreCase(name))
				.findFirst().orElse(null);
	}

}
