package me.mrletsplay.bmareas.command.area;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import me.mrletsplay.bmareas.BMAreas;
import me.mrletsplay.bmareas.command.Point;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import me.mrletsplay.mrcore.fabric.command.FabricCommandSender;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class AreaRemoveCornerCommand extends FabricCommand {

	public AreaRemoveCornerCommand() {
		super("removecorner");
		setDescription("Remove corners you've added");
		setUsage("/area removecorner <all | #index | count>");

		setTabCompleter(event -> {
			FabricCommandSender sender = (FabricCommandSender) event.getSender();
			ServerPlayerEntity p = sender.asPlayer();
			if(p == null) return Collections.emptyList();

			if(event.getArgs().length == 0) {
				List<String> s = new ArrayList<>();
				List<Point> points = BMAreas.points.get(p.getUuid());
				if(points != null) {
					for(int i = 0; i < points.size(); i++) {
						s.add("#" + (i+1));
					}
				}
				s.add("all");
				s.add("1");
				return s;
			}

			return Collections.emptyList();
		});
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 1) {
			sendCommandInfo(event.getSender());
			return;
		}

		List<Point> points = BMAreas.points.get(p.getUuid());
		if(points == null) {
			p.sendMessage(Text.literal("§cNo corners to reset"));
			return;
		}

		String what = event.getArguments()[0];
		if(what.equals("all")) {
			BMAreas.points.remove(p.getUuid());
			p.sendMessage(Text.literal("§aReset all corners"));
		}else if(what.startsWith("#")) {
			try {
				int idx = Integer.parseInt(what.substring(1)) - 1;
				if(idx < 0 || idx >= points.size()) {
					p.sendMessage(Text.literal("§aNot a valid corner index. Use §7/area listcorners §cto see valid indexes"));
					return;
				}

				points.remove(idx);
				p.sendMessage(Text.literal("§aRemoved corner at index §7" + (idx + 1)));
			}catch(NumberFormatException e) {
				sendCommandInfo(event.getSender());
			}
		}else {
			try {
				int count = Integer.parseInt(what);
				if(count < 0 || count > points.size()) {
					p.sendMessage(Text.literal("§aNot a valid amount of corners. Use §7/area listcorners §cto see how many corners you have added"));
					return;
				}

				for(int i = 0; i < count; i++) {
					points.remove(points.size() - 1);
				}

				if(points.isEmpty()) BMAreas.points.remove(p.getUuid());
				p.sendMessage(Text.literal("§aRemoved the last §7" + count + " §acorners"));
			}catch(NumberFormatException e) {
				sendCommandInfo(event.getSender());
			}
		}
	}

}
